﻿-- Portrait icons for each specialization
SPEC_PORTRAITS_LIST = {	
	"Interface\\ICONS\\Ability_Druid_OwlkinFrenzy.blp",
	"Interface\\ICONS\\INV_Staff_99.blp",
	"Interface\\ICONS\\ABILITY_DRUID_DEMORALIZINGROAR.blp",
	"Interface\\ICONS\\Ability_Druid_NaturalPerfection.blp"
}

SPEC_PORTRAITS_LIST_UNFORM = {
	"Interface\\ICONS\\INV_MISC_PETMOONKINNE.blp",
	"Interface\\ICONS\\Achievement_Halloween_Cat_01.blp",
	"Interface\\ICONS\\inv_misc_bearcubbrown.blp",
	"Interface\\ICONS\\Ability_Druid_NaturalPerfection.blp"
}

--Primary buffs for each specialization
SPEC_BUFF_LIST = {16886, 127538, 62606, 100977}

-- AlertFrame 
AlertFrame = CreateFrame("Frame"); 
AlertFrame:ClearAllPoints(); 
AlertFrame:SetHeight(100); 
AlertFrame:SetWidth(100); 
AlertFrame:SetPoint("CENTER", UIParent, "CENTER");
AlertFrame:SetScript("OnUpdate", function(self, elapsed)
	if (AlertFrame.Time < GetTime() - 3) then		
		local alpha = AlertFrame:GetAlpha()
		if (alpha ~= 0) then AlertFrame:SetAlpha(alpha - .05) end
		if (aplha == 0) then AlertFrame:Hide() end
	end
end
) 
AlertFrame:Hide(); 
AlertFrame.text = AlertFrame:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont"); 
AlertFrame.text:SetAllPoints(); 
AlertFrame.Time = 0;
  
function AlertMsg(message, color) 
	AlertFrame.text:SetText(message); 
	if color=="green" then
		AlertFrame.text:SetTextColor(0,1,0)
	elseif color == "red" then
		AlertFrame.text:SetTextColor(1,0,0)
	else 
		AlertFrame.text:SetTextColor(1,1,1)
	end
	AlertFrame:SetAlpha(1); 
	AlertFrame:Show(); 
	AlertFrame.Time = GetTime(); 
end
----------------------------------------------------------------------------------------------



function RageBar_OnLoad(self)	
	self:SetMinMaxValues(0,100)
	self:SetValue(100)
	self:SetStatusBarColor(0.8,0,0)
end

function RageBar_OnUpdate(self, elapsed)
	if GetShapeshiftFormID() == 5 then
		local currentChance = self:GetValue()
		local newChance = UnitPower("player", SPELL_POWER_RAGE)	
		if newChance - currentChance > 1 then
			self:SetValue(currentChance + 1)
		elseif newChance - currentChance <= 1  and newChance - currentChance > 0 then
			self:SetValue(newChance)
		elseif currentChance - newChance > 10 then
			self:SetValue(currentChance - 10)
		elseif currentChance - newChance > 0 and currentChance - newChance < 10 then
			self:SetValue(newChance)
		end 
		self.text:SetText(self:GetValue())
		local _, maxValue = self:GetMinMaxValues()
		self.spark:SetPoint("LEFT", self, "LEFT", self:GetValue()/maxValue*176 - 15, -1)
	else 
		self:SetValue(0)
		self.text:SetText(self:GetValue())
		self.spark:SetPoint("LEFT", self, "LEFT", - 15, -3)
	end	
end


function EnergyBar_OnLoad(self) 	
	self:SetMinMaxValues(0,100)
	self:SetValue(100)
	self:SetStatusBarColor(1, 1, 0)
end

function EnergyBar_OnUpdate(self, elasped)
	local currentChance = self:GetValue()
	local newChance = UnitPower("player", SPELL_POWER_ENERGY)	
	if newChance - currentChance > 10 then
		self:SetValue(currentChance + 10)
	elseif newChance - currentChance <= 10  and newChance - currentChance > 0 then
		self:SetValue(newChance)
	elseif currentChance - newChance > 10 then
		self:SetValue(currentChance - 10)
	elseif currentChance - newChance > 0 and currentChance - newChance < 10 then
		self:SetValue(newChance)
	end 
	self.text:SetText(self:GetValue())
	local _, maxValue = self:GetMinMaxValues()
	self.spark:SetPoint("LEFT", self, "LEFT", self:GetValue()/maxValue*176 - 15, -1)
end


function ManaBar_OnLoad(self) 		
	self:SetMinMaxValues(0, UnitPowerMax("player"))
	self:SetValue(UnitPower("player")) 
	self:SetStatusBarColor(0.0, 0.15 ,0.70)
end

function ManaBar_OnUpdate(self, elasped)
	--self:SetMinMaxValues(0, UnitPower("player", SPELL_POWER_MANA)) 
	local currentChance = self:GetValue()
	local newChance = UnitPower("player", SPELL_POWER_MANA)		
	self:SetValue(newChance)	
	local _, maxValue = self:GetMinMaxValues()
	self.spark:SetPoint("LEFT", self, "LEFT", newChance/maxValue*176 - 15, -3)
	self.text:SetText(newChance)
end


function EclipseBar_OnLoad(self)
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")	
end

function EclipseBar_OnUpdate(self, elapsed)
	MasterSS_SolarMask:SetFrameLevel(100)
	MasterSS_LunarMask:SetFrameLevel(100)
	
	local newChance = UnitPower("player", SPELL_POWER_ECLIPSE)	
	local direction = GetEclipseDirection()	
	
	if newChance >= 0 then
		MasterSS_SolarMask:SetValue(newChance)
		MasterSS_LunarMask:SetValue(0)
	elseif newChance < 0 then
		MasterSS_LunarMask:SetValue(newChance)
		MasterSS_SolarMask:SetValue(0)
	end
	
	MasterSS_LunarMask.spark:SetPoint("LEFT", MasterSS_LunarMask, "LEFT", (100 + MasterSS_LunarMask:GetValue())/100*88 - 15, -3)
	MasterSS_SolarMask.spark:SetPoint("LEFT", MasterSS_SolarMask, "LEFT", MasterSS_SolarMask:GetValue()/100*88 - 15, -3)	
	
	if (newChance > 0 and direction == "moon") or self.nextToEclipse == 1 then -- Sun Eclipse
		SolarIconActive:Show()
		SolarIcon:Hide()
		SolarIconActive.pulse:Play()
	else 
		SolarIconActive:Hide()
	end
	
	if (newChance < 0 and direction == "sun") or self.nextToEclipse == -1 then -- Moon Eclipse
		LunarIconActive:Show()
		LunarIcon:Hide()
		LunarIconActive.pulse:Play()
	else 
		LunarIconActive:Hide()
	end
	
	if newChance < 0 then
		newChance = -newChance
	end
	if direction == "moon" then
		MasterSS_EclipseBar_Text:SetText("<"..newChance)
	elseif direction == "sun" then
		MasterSS_EclipseBar_Text:SetText(newChance..">")
	else
		MasterSS_EclipseBar_Text:SetText("<"..newChance..">")
	end	
end

function EclipseBar_OnEvent(self, event, ...)
	local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...)
	
	if sourceName == UnitName("player") then
	
			if eventType == "SPELL_CAST_START" then
				local spellId, spellName, spellSchool = select(12, ...)
				local auraType = select(15, ...)
				--MasterSS:showMsg(spellId .."-".. spellName)
				local power = UnitPower("player", SPELL_POWER_ECLIPSE)
				
				if spellId == 2912  then -- starfire
					if power >= 60 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)
						SolarIconActive:Show()
						self.nextToEclipse = 1
						AlertMsg("即将进蚀", "green")
					end
					
					if power >= -40 and power < -20 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end												
				end
				
				if spellId == 5176 then --wrath
					if power <= -70 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)
						LunarIconActive:Show()
						self.nextToEclipse = -1
						AlertMsg("即将进蚀","green")
					end
					
					if power <= 35 and power > 15 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end												
				end
				
				if spellId == 78674 then -- starsurge
					if power >= 60 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)						
						self.nextToEclipse = 1
						AlertMsg("即将进蚀","green")
					end
					if power <= -60 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)						
						
						self.nextToEclipse = -1
						AlertMsg("即将进蚀","green")
					end	
					if power >= -40 and power < -20 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀","red")
					end
					if power <= 35 and power > 20 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end	
				end--starsurge				
			end--cast start
			
			if eventType == "SPELL_ENERGIZE" or eventType == "SPELL_CAST_FAILED" then
				MasterSS_EclipseBar_Text:SetTextColor(1,1,1)
				if self.nextToEclipse == -1 then
					self.nextToEclipse = 0
					LunarIconActive:Hide()
				elseif self.nextToEclipse == 1 then
					self.nextToEclipse = 0
					SolarIconActive:Hide()
				end
			end
	end	
end


-- Combo frame
local function SetCombo(id, combo, active, inCD)
	if active then
		if id == 1 or id == 4 then
			if inCD then
				combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
			else
				combo:SetTexture("Interface/COMMON/Indicator-Green.blp")
			end
		elseif id == 2 then
			combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
		elseif id == 3 then
			if inCD then
				combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
			else 	
				combo:SetTexture("Interface/COMMON/Indicator-Red.blp")
			end
		end
	else 
		combo:SetTexture("Interface/COMMON/Indicator-Gray.blp")
	end
end

function ComboBar_OnUpdate(self, elapsed)
	local spec = GetSpecialization()
	MasterSS_ComboTimer:Hide()
	if  spec == 2 then --cat
		local pts = GetComboPoints("player","target")
		if pts == 0 then
			SetCombo(spec, MasterSS_Combo1, false)
			SetCombo(spec, MasterSS_Combo2, false)
			SetCombo(spec, MasterSS_Combo3, false)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)			
		elseif pts == 1 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, false)
			SetCombo(spec, MasterSS_Combo3, false)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)		
		elseif pts == 2 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, false)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)		
		elseif pts == 3 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, true)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)		
		elseif pts == 4 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, true)
			SetCombo(spec, MasterSS_Combo4, true)
			SetCombo(spec, MasterSS_Combo5, false)
		elseif pts == 5 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, true)
			SetCombo(spec, MasterSS_Combo4, true)
			SetCombo(spec, MasterSS_Combo5, true)
		end
	elseif spec == 3 then -- Bear
		local pts, maxCharges, timeLastCast, cooldownDuration  = GetSpellCharges(62606)
		local left = cooldownDuration - GetTime() + timeLastCast
		MasterSS_ComboTimer:SetText(string.format("%d", left))
		MasterSS_ComboTimer:Show()
		local _, _, _, powerCost = GetSpellInfo(62606) 
		local low = UnitPower("player", SPELL_POWER_RAGE) < powerCost
		if pts == 0 then		
			MasterSS_ComboTimer:SetPoint("CENTER", MasterSS_Combo3, "CENTER",1,2)
			SetCombo(spec, MasterSS_Combo3, false, low)
			SetCombo(spec, MasterSS_Combo4, false, low)
			SetCombo(spec, MasterSS_Combo5, false, low)			
		elseif pts == 1 then			
			MasterSS_ComboTimer:SetPoint("CENTER", MasterSS_Combo4, "CENTER",1,2)
			SetCombo(spec, MasterSS_Combo3, true, low)
			SetCombo(spec, MasterSS_Combo4, false, low)
			SetCombo(spec, MasterSS_Combo5, false, low)		
		elseif pts == 2 then			
			MasterSS_ComboTimer:SetPoint("CENTER", MasterSS_Combo5, "CENTER",1,2)
			SetCombo(spec, MasterSS_Combo3, true, low)
			SetCombo(spec, MasterSS_Combo4, true, low)
			SetCombo(spec, MasterSS_Combo5, false, low)		
		elseif pts == 3 then			
			MasterSS_ComboTimer:Hide()
			SetCombo(spec, MasterSS_Combo3, true, low)
			SetCombo(spec, MasterSS_Combo4, true, low)
			SetCombo(spec, MasterSS_Combo5, true, low)	
		end	
	elseif spec == 1 or spec == 4 then -- moonkin mushroom
		local pts = 0
		local i
		for i = 1,3 do
			local haveTotem, _, _, _, _ = GetTotemInfo(i)
			if haveTotem then 
				pts = pts + 1
			end
		end
		local start1, _,_ = GetSpellCooldown(88751)
		local start2, _,_ = GetSpellCooldown(102791)
		local inCD = start1 ~= 0 or start2 ~= 0
		if pts == 0 then			
			SetCombo(spec, MasterSS_Combo3, false, inCD)
			SetCombo(spec, MasterSS_Combo4, false, inCD)
			SetCombo(spec, MasterSS_Combo5, false)			
		elseif pts == 1 then			
			SetCombo(spec, MasterSS_Combo3, true, inCD)
			SetCombo(spec, MasterSS_Combo4, false, inCD)
			SetCombo(spec, MasterSS_Combo5, false, inCD)		
		elseif pts == 2 then			
			SetCombo(spec, MasterSS_Combo3, true, inCD)
			SetCombo(spec, MasterSS_Combo4, true, inCD)
			SetCombo(spec, MasterSS_Combo5, false, inCD)		
		elseif pts == 3 then			
			SetCombo(spec, MasterSS_Combo3, true,inCD)
			SetCombo(spec, MasterSS_Combo4, true,inCD)
			SetCombo(spec, MasterSS_Combo5, true,inCD)	
		end
	end
end

-- Provoked after changing specialization
function ResetComboBar()
	local spec = GetSpecialization()
	if spec == 2 then
		MasterSS_ComboBorder1:Show()
		MasterSS_ComboBorder2:Show()
		MasterSS_Combo1:Show()
		MasterSS_Combo2:Show()
	else 
		MasterSS_ComboBorder1:Hide()
		MasterSS_ComboBorder2:Hide()
		MasterSS_Combo1:Hide()
		MasterSS_Combo2:Hide()
	end	
end 


-- Primary buff bar
function BuffBar_OnUpdate(self, elapsed)
	self.total = self.total + elapsed
	
	if self.total >= .1 then		
		self.total = 0
		if MasterSS_BuffStatusBar:GetValue() > 0 then
			MasterSS_BuffStatusBar:SetValue(MasterSS_BuffStatusBar:GetValue() - 0.1)
			BuffBar_Text:SetText(string.format("%.1f", MasterSS_BuffStatusBar:GetValue()))
		else
			BuffBar_Text:SetText("")
		end
		if GetSpecialization() == 3 then
			BuffBar_Text2:SetText(string.format("%.1f",GetDodgeChance()).."%")
		end
	end	
end

function BuffBar_OnEvent(self, event, ...)
	local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...)
	if sourceName == UnitName("player") then
		--print(eventType)
		if eventType == "SPELL_CAST_SUCCESS" or eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH" then
			local spellId, spellName, spellSchool = select(12, ...)
			local auraType = select(15, ...)
			--print(eventType.."-"..spellId.."-"..spellName)
			if spellId == SPEC_BUFF_LIST[GetSpecialization()] then
				local name, rank, icon, count, dispelType, duration, expires = UnitBuff("player", spellName)
				MasterSS_BuffStatusBar:SetValue(duration)		
				MasterSS_BuffPortrait:SetTexture(icon)
			end			
		end
	end
end


-- Aura frame
--[[
function AuraSlot_OnEvent(self, event, ...)
	local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...)
	if sourceName == UnitName("player") then
		--print(eventType)
		if eventType == "SPELL_CAST_SUCCESS" then
			local spellId, spellName, spellSchool = select(12, ...)
			local auraType = select(15, ...)
			--print(eventType.."-"..spellId.."-"..spellName)
			if spellId == self.spellId then
				local start, duration, enable = GetSpellCooldown(spellId)
				self.cooldown:SetCooldown(GetTime(), duration)
			end			
		end
	end
end
]]

-- Debuff
local DEBUFF_LIST = {
	{nil, nil, 93402,8921}, --Moonkin
	{1079, 1822, 113746, 106830}, --Cat
	{nil, 113746, 33745, 77758}, --Bear
	{nil, nil, nil, nil}
}

--Cast-when-ready
local BUFF1_LIST = {
	{78674, 48505}, --Moonkin
	{5217, nil}, --Cat
	{33878, nil}, --Bear
	{18562, 48438} -- resto
}

--Long-cd
local BUFF2_LIST = {
	{112071, 102560}, --Moonkin
	{106952, 102543}, --Cat
	{106952, 102558}, --Bear
	{740, 117679} --resto
}

local function SetDebuff(slot, id)
	if id ~= nil then
		local n = GetSpellInfo(id)
		local name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3 = UnitDebuff("target", n)
		if name ~= nil then
			slot.cooldown:SetReverse(true)
			slot.cooldown:SetCooldown(expires - duration, duration)
			slot.bg:SetAlpha(1.0)
			slot.bg:SetTexture(icon)
			local leftTime = format("%d", expires - GetTime())
			if expires - GetTime() >= 3 then
				slot.text:SetTextColor(0,1,0)
			else 
				slot.text:SetTextColor(1,0,0)
			end
			slot.text:SetText(leftTime)
			slot.text:Show()
		else 
			slot.bg:SetAlpha(0.5)
			slot.text:Hide()
			slot.cooldown:SetCooldown(0,0)
		end		
	end
end

local function SetBuff(slot, id, glow)	
	slot.spellId = id
	if id ~= nil and slot:IsShown() then
		local n = GetSpellInfo(id)
		local name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3 = UnitBuff("player", n)
		if name ~= nil then --active
			slot.bg:SetAlpha(1.0)
			slot.bg:SetTexture(icon)
			local leftTime = format("%d", expires - GetTime())			
			slot.text:SetTextColor(0,1,0)			
			slot.text:SetText(leftTime)
			slot.text:Show()
		else 
			local start, duration, enable = GetSpellCooldown(id)
			slot.cooldown:SetCooldown(start, duration)
			if start ~= 0 and duration > 1.5 then --In CD
				
				slot.bg:SetAlpha(0.5)
				slot.text:SetTextColor(1,0,0)
				local leftTime = duration - GetTime() + start
				local t
				slot.text:SetFontObject("PVPInfoTextFont")
				if leftTime >= 60 then
					slot.text:SetFontObject("NumberFont_Shadow_Small")
					t = format("%d", leftTime/60) .. ":" .. format("%02d", leftTime%60)
				elseif leftTime >= 1 then
					t = format("%d", leftTime)
				elseif leftTime >0 then
					t = format("%.1f", leftTime)	
				end
				slot.text:Show()
				slot.text:SetText(t)
				if glow and slot.glow.playing == 1 then
					slot.glow:Hide()
					slot.glow.animIn:Stop()
					slot.glow.playing = 0
				end
			else -- CD ready
				slot.bg:SetAlpha(1)
				slot.text:Hide()
				if glow and slot.glow.playing == 0 then
					slot.glow:Show()
					slot.glow.animIn:Play()
					slot.glow.playing = 1
				end
			end			
		end		
	end
end

local function SetAuraSlot(slot, id, hidden)
	if id ~= nil and not hidden then
		slot.bg:SetTexture(select(3, GetSpellInfo(id)))
		slot:Show()
		slot.cooldown:SetCooldown(0,0)
	else 
		slot:Hide()
	end
end

-- Provoked when player change specialization or talent
function UpdateIcon(spec)
	if spec == 1 or spec == 2 or spec == 3 or spec == 4 then
		SetAuraSlot(MasterSS_BuffFrame1.slot1, BUFF1_LIST[spec][1])
		SetAuraSlot(MasterSS_BuffFrame1.slot2, BUFF1_LIST[spec][2])
		
		local isFree, index = GetTalentRowSelectionInfo(4)
		local hidden = index ~= 11 -- incarnation
		SetAuraSlot(MasterSS_BuffFrame2.slot1, BUFF2_LIST[spec][1])
		SetAuraSlot(MasterSS_BuffFrame2.slot2, BUFF2_LIST[spec][2], hidden)
				
		SetAuraSlot(MasterSS_DebuffFrame.slot1, DEBUFF_LIST[spec][1])
		SetAuraSlot(MasterSS_DebuffFrame.slot2, DEBUFF_LIST[spec][2])
		SetAuraSlot(MasterSS_DebuffFrame.slot3, DEBUFF_LIST[spec][3])
		SetAuraSlot(MasterSS_DebuffFrame.slot4, DEBUFF_LIST[spec][4])
	end
end

function DebuffFrame_OnUpdate(self, elapsed)
	local spec = GetSpecialization()
	if spec == 1 or spec == 2 or spec == 3 or spec == 4 then
		SetDebuff(self.slot1, DEBUFF_LIST[spec][1])
		SetDebuff(self.slot2, DEBUFF_LIST[spec][2])
		SetDebuff(self.slot3, DEBUFF_LIST[spec][3])
		SetDebuff(self.slot4, DEBUFF_LIST[spec][4])
	end
end

function BuffFrame1_OnUpdate(self,elapsed) 
	local spec = GetSpecialization()
	if spec == 1 or spec == 2 or spec == 3 or spec == 4 then		
		SetBuff(self.slot1, BUFF1_LIST[spec][1], true)
		SetBuff(self.slot2, BUFF1_LIST[spec][2], true)
	end
end

function BuffFrame2_OnUpdate(self,elapsed) 
	local spec = GetSpecialization()
	if spec == 1 or spec == 2 or spec == 3 or spec == 4 then		
		SetBuff(self.slot1, BUFF2_LIST[spec][1])
		SetBuff(self.slot2, BUFF2_LIST[spec][2])
	end
end



-- Update player portrait icon
function UpdatePortrait() 
	if UnitIsDeadOrGhost("player") == 1 then
		MasterSS_Portrait:SetTexture("Interface\\ICONS\\INV_MISC_FOOD_15.blp")
	elseif GetSpecialization() == nil then
		MasterSS_Portrait:SetTexture("Interface\\ICONS\\Ability_Druid_MasterShapeshifter.blp")
	else
		if GetShapeshiftFormID() == nil then
			MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[GetSpecialization()])
		else			
			if (GetSpecialization() == 1 and GetShapeshiftFormID() == 31) or (GetSpecialization() == 2 and GetShapeshiftFormID() == 1) or (GetSpecialization() == 3 and GetShapeshiftFormID() == 5) then
				MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST[GetSpecialization()])
			else
				MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[GetSpecialization()])
			end
		end
	end
end 

-- Re-organize frame after changing specialization
function applySpecialization()
	SPEC_ID = GetSpecialization()	
	
	MasterSS.RageBar:Hide()
	MasterSS.EnergyBar:Hide()
	MasterSS.ManaBar:Hide()
	MasterSS.EclipseBar:Hide()
	
	ResetComboBar()
	MasterSS_ComboFrame:Show()

	UpdateIcon(SPEC_ID)	
	
	MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[SPEC_ID])
	ManaBar_OnLoad(MasterSS.ManaBar)
	
	if SPEC_ID == 1 then --Monnkin
		MasterSS.EclipseBar:Show()
		MasterSS_BuffStatusBar:SetMinMaxValues(0,18)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.13,0.93,0)
		MasterSS_BuffStatusBar.text:Hide()
		
	elseif SPEC_ID == 2 then --Cat
		MasterSS.EnergyBar:Show()	
		MasterSS_BuffStatusBar:SetMinMaxValues(0,45)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.75,0,0)
		MasterSS_BuffStatusBar.text:Hide()
		
	elseif SPEC_ID == 3 then --Bear
		MasterSS.RageBar:Show()
		MasterSS_BuffStatusBar:SetMinMaxValues(0,18)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.73,0.73,0)
		MasterSS_BuffStatusBar.text:Show()
	elseif SPEC_ID == 4 then --Tree
		MasterSS.ManaBar:Show()
		MasterSS_BuffStatusBar:SetMinMaxValues(0,20)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.93,0.93,0)
		MasterSS_BuffStatusBar.text:Hide()
	end	
end

function MSS_OnChangeForm()	
	if MSS_SavedOptions["switch_on_shapeshift"] == 1 then
		MasterSS.RageBar:Hide()
		MasterSS.EnergyBar:Hide()
		MasterSS.ManaBar:Hide()
		MasterSS.EclipseBar:Hide()
		local formId = GetShapeshiftFormID()
		local specId = GetSpecialization()
		if formId == 5 then
			MasterSS.RageBar:Show()
		elseif formId == 1 then
			MasterSS.EnergyBar:Show()
		elseif formId == 31 then --moonkin
			MasterSS.EclipseBar:Show()
		else
			if specId == 1 then
				MasterSS.EclipseBar:Show()
			else 
				MasterSS.ManaBar:Show()
			end
		end
	end
end

function MSS_OnEvent(self, event, ...)
	if event == "PLAYER_SPECIALIZATION_CHANGED" or event == "PLAYER_ENTERING_WORLD" then
		applySpecialization()
		MSS_OnChangeForm()	
	elseif event == "PLAYER_REGEN_DISABLED" then
		
		if MSS_SavedOptions["enable_mss"] == 1 and MSS_SavedOptions["hide_no_combat"] == 1 then
			self:Show()
			MasterSSMask:Show()
		end
	elseif event == "PLAYER_REGEN_ENABLED" then
		if MSS_SavedOptions["enable_mss"] == 1 and MSS_SavedOptions["hide_no_combat"] == 1 then
			self:Hide()
			MasterSSMask:Hide()
		end
	elseif event == "UPDATE_SHAPESHIFT_FORM" then
		MSS_OnChangeForm()	
	end
end

function MSS_Float_PreditorySwiftness_OnUpdate(self, elapsed)
	local n = GetSpellInfo(16974)
	local name, rank, icon, count, dispelType, duration, expires = UnitBuff("player", n)
		
	if MSS_SavedOptions["lock_float_icon"] == 0 then
		self.image:Show()
	elseif name ~= nil then
		if self.isPlaying == 0 then
			self.image.pulse:Play()			
			self.isPlaying = 1
		end		
		self.image:Show()
		self.text:SetText(format("%d", expires - GetTime()))
		self.text:Show()		
	else 
		self.image:Hide()
		self.text:Hide()
		self.textCount:Hide()
	end	
end

function MSS_Float_DoC_OnUpdate(self, elapsed)
	local n = GetSpellInfo(108373)
	local name, rank, icon, count, dispelType, duration, expires = UnitBuff("player", n)		
	if name ~= nil then
		if self.isPlaying == 0 then
				self.image.pulse:Play()			
				self.isPlaying = 1
		end		
		self.image:Show()
		self.text:SetText(format("%d", expires - GetTime()))
		self.text:Show()
		self.textCount:SetText(count)
		self.textCount:Show()
	else 
		self.image:Hide()
		self.text:Hide()
		self.textCount:Hide()
	end	
end

--local tttt = 0
-- Player HP bar
function MyHpBar_OnUpdate(self, elapsed)
	local maxhp = UnitHealthMax("player")
	local hp = UnitHealth("player")
	self:SetMinMaxValues(0, maxhp)
	
	local baseAP, pos, neg = UnitAttackPower("player")
	local AP = baseAP + pos - neg
	local Agi = UnitStat("player", 2)
	local stamina = UnitStat("player", 3)	
	local modifier = max(2 * (AP - (Agi*2)), stamina * 2.5) 
	-- tttt = tttt + elapsed
	-- if tttt > 5 then
	--	print(modifier)
	--	tttt = 0
	-- end
	if UnitPower("player", SPELL_POWER_RAGE) < 60 then
		modifier = modifier * UnitPower("player", SPELL_POWER_RAGE) / 60
	end
	-- print(modifier)
	self:SetValue(hp + (modifier))	
	
	MSS_RealHpBar:SetMinMaxValues(0, maxhp)
	MSS_RealHpBar:SetValue(hp)	
	if hp / maxhp >= 0.25 then
		MSS_RealHpBar:SetStatusBarColor(0,1,0)
	else
		MSS_RealHpBar:SetStatusBarColor(0.8,0,0)
	end
end


-- Target HP bar
function TargetHpBar_OnUpdate(self, elapsed)
	local maxhp = UnitHealthMax("target")
	local hp = UnitHealth("target")
	if maxhp == 0 then
		self:SetAlpha(0)
	else		
		self:SetAlpha(1)
		self:SetMinMaxValues(0, maxhp)
		self:SetValue(hp)
		if hp / maxhp >= 0.8 then
			self:SetStatusBarColor(0, 1, 0)
		elseif hp / maxhp >= 0.25 then
			self:SetStatusBarColor(1,1,0)
		else
			self:SetStatusBarColor(0.8,0,0)
		end
	end
end


